org.apache.ignite

## Interface IgniteCountDownLatch

All Superinterfaces:
  AutoCloseable, Closeable

All Known Subinterfaces:
  GridCacheCountDownLatchEx

All Known Implementing Classes:
  GridCacheCountDownLatchImpl

    public interface IgniteCountDownLatch
    extends Closeable

This interface provides a rich API for working with distributed count down latch.

# Functionality

Distributed count down latch provides functionality similar to `java.util.CountDownLatch`. Note that you cannot remove count down latch having count greater that zero. It should be counted down to zero first.

# Creating Distributed Count Down Latch

Instance of cache count down latch can be created by calling the following method: `Ignite.countDownLatch(String, int, boolean, boolean)`.

### Method Summary

Methods
`boolean` `autoDelete()` Gets `autoDelete` flag.
`void` `await()` Causes the current thread to wait until the latch has counted down to zero, unless current thread is interrupted.
`boolean` `await(long timeout)` Causes the current thread to wait until the latch has counted down to zero, unless the thread is interrupted, or the specified waiting time elapses.
`boolean` `await(long timeout, TimeUnit unit)` Causes the current thread to wait until the latch has counted down to zero, unless the thread is interrupted, or the specified waiting time elapses.
`void` `close()` Removes this count down latch.
`int` `count()` Gets current count value of the latch.
`int` `countDown()` Decrements the count of the latch, releasing all waiting threads on all nodes if the count reaches zero.
`int` `countDown(int val)` Decreases the count of the latch using passed in value, releasing all waiting threads on all nodes if the count reaches zero.
`void` `countDownAll()` Counts down this latch to zero, releasing all waiting threads on all nodes.
`int` `initialCount()` Gets initial count value of the latch.
`String` `name()` Gets name of the latch.
`boolean` `removed()` Gets `removed` status of the latch.

### Method Detail

#### name

    String name()

Gets name of the latch.

Returns:
  Name of the latch.

#### count

    int count()

Gets current count value of the latch.

Returns:
  Current count.

#### initialCount

    int initialCount()

Gets initial count value of the latch.

Returns:
  Initial count.

#### autoDelete

    boolean autoDelete()

Gets `autoDelete` flag. If this flag is `true` latch is removed from cache when it has been counted down to 0.

Returns:
  Value of `autoDelete` flag.

#### await

    void await()
               throws IgniteException

Causes the current thread to wait until the latch has counted down to zero, unless current thread is interrupted.

If the current count of the latch is zero then this method returns immediately.

If the current count is greater than zero then the current thread becomes disabled for thread scheduling purposes and lies dormant until one of two things happen:

- The count reaches zero due to invocations of the `countDown()` method on any node; or
- Some other thread interrupts the current thread.

If the current thread:

- has its interrupted status set on entry to this method; or
- is interrupted while waiting,

then `IgniteInterruptedCheckedException` is thrown and the current thread's interrupted status is cleared.

Throws:
  `IgniteException` - If operation failed.
  `IgniteInterruptedException` - if the current thread is interrupted while waiting

#### await

    boolean await(long timeout)
                  throws IgniteException

Causes the current thread to wait until the latch has counted down to zero, unless the thread is interrupted, or the specified waiting time elapses.

If the current count is zero then this method returns immediately with the value `true`.

If the current count is greater than zero then the current thread becomes disabled for thread scheduling purposes and lies dormant until one of three things happen:

- The count reaches zero due to invocations of the `countDown()` method on any node; or
- Some other thread interrupts the current thread; or
- The specified waiting time elapses.

If the count reaches zero then the method returns with the value `true`.

If the current thread:

- has its interrupted status set on entry to this method; or
- is interrupted while waiting,

then `IgniteInterruptedCheckedException` is thrown and the current thread's interrupted status is cleared.

If the specified waiting time elapses then the value `false` is returned. If the time is less than or equal to zero, the method will not wait at all.

Parameters:
  `timeout` - The maximum time to wait in milliseconds.
Returns:
  `True` if the count reached zero and `false` if the waiting time elapsed before the count reached zero.
Throws:
  `IgniteInterruptedException` - If the current thread is interrupted while waiting.
  `IgniteException` - If operation failed.

#### await

    boolean await(long timeout,
                TimeUnit unit)
                  throws IgniteException

Causes the current thread to wait until the latch has counted down to zero, unless the thread is interrupted, or the specified waiting time elapses.

If the current count is zero then this method returns immediately with the value `true`.

If the current count is greater than zero then the current thread becomes disabled for thread scheduling purposes and lies dormant until one of three things happen:

- The count reaches zero due to invocations of the `countDown()` method on any node; or
- Some other thread interrupts the current thread; or
- The specified waiting time elapses.

If the count reaches zero then the method returns with the value `true`.

If the current thread:

- has its interrupted status set on entry to this method; or
- is interrupted while waiting,

then `IgniteInterruptedCheckedException` is thrown and the current thread's interrupted status is cleared.

If the specified waiting time elapses then the value `false` is returned. If the time is less than or equal to zero, the method will not wait at all.

Parameters:
  `timeout` - The maximum time to wait.
  `unit` - The time unit of the `timeout` argument.
Returns:
  `True` if the count reached zero and `false` if the waiting time elapsed before the count reached zero.
Throws:
  `IgniteInterruptedException` - If the current thread is interrupted while waiting.
  `IgniteException` - If operation failed.

#### countDown

    int countDown()
                  throws IgniteException

Decrements the count of the latch, releasing all waiting threads on all nodes if the count reaches zero.

If the current count is greater than zero then it is decremented. If the new count is zero then all waiting threads are re-enabled for thread scheduling purposes.

If the current count equals zero then nothing happens.

Returns:
  Count after decrement.
Throws:
  `IgniteException` - If operation failed.

#### countDown

    int countDown(int val)
                  throws IgniteException

Decreases the count of the latch using passed in value, releasing all waiting threads on all nodes if the count reaches zero.

If the current count is greater than zero then it is decreased. If the new count is zero then all waiting threads are re-enabled for thread scheduling purposes.

If the current count equals zero then nothing happens.

Parameters:
  `val` - Value to decrease counter on.
Returns:
  Count after decreasing.
Throws:
  `IgniteException` - If operation failed.

#### countDownAll

    void countDownAll()
                      throws IgniteException

Counts down this latch to zero, releasing all waiting threads on all nodes.

If the current count equals zero then nothing happens.

Throws:
  `IgniteException` - If operation failed.

#### removed

    boolean removed()

Gets `removed` status of the latch.

Returns:
  `True` if latch was removed from cache, `false` otherwise.

#### close

    void close()

Removes this count down latch.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Throws:
  `IgniteException` - If operation failed.

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.0.0-RC1
Release Date | : February 17 2015